import java.util.LinkedList;

public class City {

	private String name;
	private boolean visited;
	private LinkedList<City> destinations;
	
	public City(String name) {
		this.name = name;
		this.visited = false;
		destinations = new LinkedList<City>();
	}
	
	public void addDestination(City destination) {
		destinations.add(destination);
	}
	
	public City[] getDestinations() {
		City[] cities = new City[destinations.size()];

		for ( int i = 0 ; i < destinations.size() ; i++ ) {
			cities[i] = destinations.get(i);
		}
		
		return cities;
	}

	public City[] getAllUnvisitedCities() {
		City[] cities = new City[destinations.size()];
		int count = 0;

		for ( int i = 0 ; i < destinations.size() ; i++ ) {
			if (!destinations.get(i).isVisited()) {
				cities[count++] = destinations.get(i);
			}
		}
		
		if (count == 0) {
			return null;
		} else if (count == destinations.size()) {
			return cities;
		} else {
			City[] unvisited = new City[count];
			for ( int i = 0 ; i < count ; i++ ) {
				unvisited[i] = cities[i];
			}
			return unvisited;
		}
		
	}
	
	
	public boolean isVisited() {
		return visited;
	}

	public void setVisited(boolean visited) {
		this.visited = visited;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof City) {
			City city = (City) obj;
			if (this.name.equals(city.getName())) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	@Override
	public String toString() {
		return this.name;
	}
	
	
	
	
}
