import java.util.Stack;

public class TripFinder {

	private static City newYork, providence, boston, philadelphia, 
	washington, miami, dallas, chicago, sanFrancisco, losAngeles;
	
	public TripFinder() {
		this.newYork = new City("New York");
		this.providence = new City("Providence");
		this.boston = new City("Boston");
		this.philadelphia = new City("Philadelphia");
		this.washington = new City("Washington DC");
		this.miami = new City("Miami");
		this.dallas = new City("Dallas");
		this.chicago = new City("Chicago");
		this.sanFrancisco = new City("San Francisco");
		this.losAngeles = new City("Los Angeles");
		
		newYork.addDestination(dallas);
		newYork.addDestination(washington);
		newYork.addDestination(providence);
		newYork.addDestination(boston);
		newYork.addDestination(philadelphia);
		newYork.addDestination(miami);
		boston.addDestination(providence);
		philadelphia.addDestination(newYork);
		philadelphia.addDestination(boston);
		washington.addDestination(miami);
		washington.addDestination(chicago);
		dallas.addDestination(chicago);
		chicago.addDestination(boston);
		chicago.addDestination(sanFrancisco);
		sanFrancisco.addDestination(losAngeles);
		losAngeles.addDestination(washington);
	}
	
	
	public static void main(String[] args) {
		TripFinder tf = new TripFinder();
		
		Stack<City> stack = new Stack<City>();
		
		City origin = newYork;
		City destination = losAngeles;
		
		stack.push(origin);
		origin.setVisited(true);
		System.out.println(stack);
		
		while(!stack.isEmpty() && !stack.peek().equals(destination)) {
			City[] cities = stack.peek().getAllUnvisitedCities();
			
			if (cities != null) {
				for ( int i = 0 ; i < cities.length ; i++ ) {
					stack.push(cities[i]);
					cities[i].setVisited(true);
				}
			} else { 
				stack.pop();
			}
			
			System.out.println(stack);
		}
		
		if (stack.isEmpty()) {
			System.out.println("No route exists from " + origin + " to " + destination);
		} else {
			System.out.println("There is a route from " + origin + " to " + destination);
		}
		

	}

}
